# Contributing

Material for MkDocs is an actively maintained and constantly improved project 
that caters to a diverse user base with varying backgrounds and needs. In order
to effectively address the needs of all our users, evaluate requests, and fix 
bugs, a lot of work from us maintainers is required.

## How to contribute

We have invested quite a lot of time in creating better templates for our
[issue tracker], optimizing the processes for our users to report bugs, request
features or changes, contribute to the project, or exchange with our community. 
This section of the documentation explains each process.

  [issue tracker]: https://github.com/squidfunk/mkdocs-material/issues

### Creating an issue

<div class="grid cards" markdown>

-   :material-bug:{ .lg .middle } __Something is not working?__

    ---

    Report a bug in Material for MkDocs by creating an issue and a reproduction

    [:octicons-arrow-right-24: Report a bug][report a bug]

-   :material-file-document:{ .lg .middle } __Missing information in our docs?__

    ---

    Report missing information or potential inconsistencies in our documentation

    [:octicons-arrow-right-24: Report a docs issue][report a docs issue]

-   :material-lightbulb-on:{ .lg .middle } __Want to submit an idea?__

    ---

    Propose a change or feature request or suggest an improvement

    [:octicons-arrow-right-24: Request a change][request a change]

-   :material-chat-question:{ .lg .middle } __Have a question or need help?__

    ---

    Ask questions on our discussion board and get in touch with our community

    [:octicons-arrow-right-24: Ask a question][ask a question]

</div>

  [report a bug]: reporting-a-bug.md
  [report a docs issue]: reporting-a-docs-issue.md
  [request a change]: requesting-a-change.md
  [ask a question]: https://github.com/squidfunk/mkdocs-material/discussions
